using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using System.Transactions;
using System.Data.SqlClient;
using System.Threading;
using System.Reflection;

namespace Exferia_Hermes._1_Datos
{
    public class HRM_PreciosCombustible_Historico_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            List<dynamic> _lst_return = null;
            try
            {
                string str_SQL = Obtener_Consulta_Modelo();

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL, new string[] { });
                _lst_return = g_lst_HRM_PreciosCombustible_Historico?.Cast<dynamic>().ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_PreciosCombustible_Historico) + "/" + nameof(Obtener_Listado), true);
            }

            return _lst_return;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {

            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion


        #region Obtener

        private static int g_int_TotalHilos_Obtener = 1;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                   $@"SELECT distinct 
                       {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.id)}, 
                       {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.idValoresGenerales)}, 
                       {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.precio)}, 
                       {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.fecha)},
                       {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.fechaBorrado)}
                    FROM {nameof(HRM_PreciosCombustible_Historico)}
                    WHERE {nameof(HRM_PreciosCombustible_Historico.id)} = @id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<HRM_PreciosCombustible_Historico>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_PreciosCombustible_Historico_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion
        #region Tablas Relacionadas
        #endregion Tablas Relacionadas
        #region MODELOS

        #region Modelo Simple
        private HRM_PreciosCombustible_Historico g_mdl_HRM_PreciosCombustible_Historico = null;
        public HRM_PreciosCombustible_Historico Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 $@" WHERE {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.id)} = @id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_PreciosCombustible_Historico_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_HRM_PreciosCombustible_Historico;
        }
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_HRM_PreciosCombustible_Historico = obj_Exferia_Entities.Database.SqlQuery<HRM_PreciosCombustible_Historico>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_PreciosCombustible_Historico_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelos Listado
        private List<HRM_PreciosCombustible_Historico> g_lst_HRM_PreciosCombustible_Historico = null;

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                     object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el modelo
                g_lst_HRM_PreciosCombustible_Historico = obj_Exferia_Entities.Database.SqlQuery<HRM_PreciosCombustible_Historico>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_PreciosCombustible_Historico_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                $@"SELECT 
                    {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.id)}, 
                    {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.idValoresGenerales)},
                    {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.precio)}, 
                    {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.fecha)}, 
                    {nameof(HRM_PreciosCombustible_Historico)}.{nameof(HRM_PreciosCombustible_Historico.fechaBorrado)}
                 FROM {nameof(HRM_PreciosCombustible_Historico)}";
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                HRM_PreciosCombustible_Historico mdl_HRM_PreciosCombustible_Historico_AGrabar = (HRM_PreciosCombustible_Historico)_mdl_obj;
                HRM_PreciosCombustible_Historico mdl_HRM_PreciosCombustible_Historico_DatosViejos = new HRM_PreciosCombustible_Historico();

                // Ver si existe ######################################################################
                HRM_PreciosCombustible_Historico mdl_HRM_PreciosCombustible_Historico_Final = Obtener_Modelo_Por_Id(mdl_HRM_PreciosCombustible_Historico_AGrabar.id);
                //######################################################################################             

                //UPDATE
                if (mdl_HRM_PreciosCombustible_Historico_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos Viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_HRM_PreciosCombustible_Historico_Final, mdl_HRM_PreciosCombustible_Historico_DatosViejos, false, false);

                    //Cargar los Datos Nuevos para la Trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_HRM_PreciosCombustible_Historico_AGrabar, mdl_HRM_PreciosCombustible_Historico_Final, false, false);

                    #region UPDATE
                    string str_SQL_Update = $@"UPDATE {nameof(HRM_PreciosCombustible_Historico)}
                                               SET 
                                                   {nameof(HRM_PreciosCombustible_Historico.idValoresGenerales)} = @idValoresGenerales,
                                                   {nameof(HRM_PreciosCombustible_Historico.precio)} = @precio,
                                                   {nameof(HRM_PreciosCombustible_Historico.fecha)} = @fecha
                                                WHERE 
                                                   {nameof(HRM_PreciosCombustible_Historico.id)} = @id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@id",  mdl_HRM_PreciosCombustible_Historico_AGrabar.id),
                        new SqlParameter("@idValoresGenerales",  mdl_HRM_PreciosCombustible_Historico_AGrabar.idValoresGenerales),
                        new SqlParameter("@precio",  mdl_HRM_PreciosCombustible_Historico_AGrabar.precio),
                        new SqlParameter("@fecha",  mdl_HRM_PreciosCombustible_Historico_AGrabar.fecha)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_HRM_PreciosCombustible_Historico_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_HRM_PreciosCombustible_Historico_Final = new HRM_PreciosCombustible_Historico();

                    //Tipo de Accdion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos Del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_HRM_PreciosCombustible_Historico_AGrabar, mdl_HRM_PreciosCombustible_Historico_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = $@" INSERT INTO {nameof(HRM_PreciosCombustible_Historico)}
                                                (
                                                       {nameof(HRM_PreciosCombustible_Historico.idValoresGenerales)}, 
                                                       {nameof(HRM_PreciosCombustible_Historico.precio)}, 
                                                       {nameof(HRM_PreciosCombustible_Historico.fecha)}
                                               ) 
                                               OUTPUT INSERTED.{nameof(HRM_PreciosCombustible_Historico.id)}
                                               VALUES
                                               ( 
                                                   @idValoresGenerales,
                                                   @precio,
                                                   @fecha
                                               )";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idValoresGenerales",  mdl_HRM_PreciosCombustible_Historico_AGrabar.idValoresGenerales),
                        new SqlParameter("@precio",  mdl_HRM_PreciosCombustible_Historico_AGrabar.precio),
                        new SqlParameter("@fecha",  mdl_HRM_PreciosCombustible_Historico_AGrabar.fecha)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(HRM_PreciosCombustible_Historico), mdl_HRM_PreciosCombustible_Historico_DatosViejos, mdl_HRM_PreciosCombustible_Historico_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_PreciosCombustible_Historico_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                HRM_PreciosCombustible_Historico mdl_HRM_PreciosCombustible_Historico_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_HRM_PreciosCombustible_Historico_Final != null)
                {
                    #region Delete
                    string str_SQL_Delete = $@" DELETE FROM  {nameof(HRM_PreciosCombustible_Historico)}
                                                WHERE  {nameof(HRM_PreciosCombustible_Historico.id)} = @id";
                    //Parametros
                    object[] arr_Parametros_Delete = new object[]
                    {
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Delete
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                    //Devolver también el objeto
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_HRM_PreciosCombustible_Historico_Final.id;
                }

                //Devolver tambien el objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_PreciosCombustible_Historico_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_ids_ABorrar = (List<long>)_mdl_obj;
                if (lst_ids_ABorrar != null & lst_ids_ABorrar.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_ids_ABorrar);

                    string str_SQL = $@" DELETE FROM {nameof(HRM_PreciosCombustible_Historico)}
                                      WHERE {nameof(HRM_PreciosCombustible_Historico.id)} in ({str_Filtro_IDS})";

                    //Parametros
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    object[] arr_Parametros = lst_Parametros.ToArray();

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL, arr_Parametros);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_PreciosCombustible_Historico_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
